config/routes.rb
# encoding: utf-8
class CourseConstraint
  def matches?(request)
    params = request.path_parameters
    tmp_course = Course.find(params[:id])
    return false if params[:course] != tmp_course.course.parameterize('_')
    true
  end  
end

class MediaConstraint
  def matches?(request)
    obj = request.fullpath.include?('media') ? Media : Audio
    params = request.path_parameters
    tmp = obj.find(params[:id])
    return false if params[:end_date] != tmp.end_date
    true
  end  
end
  
Rails.application.routes.draw do
  root 'welcome#index'
  get 'welcome/index'
  get '/ruby-version' => 'application#ruby_version'
  resources :media do
   collection do
     get 'search', to: 'media#search'
   end 
  end
  resources :audios do
   collection do
     get 'search', to: 'audios#search'
   end 
  end  
  resources :courses do
   collection do
     post 'add_to_course', to: 'courses#add_to_course'
     get 'search', to: 'courses#search'
     get 'clone_course', to: 'courses#clone_course'
     get 'send_email', to: 'courses#send_email'
     get 'archive', to: 'courses#archive'
     get 'archive_search', to: 'courses#archive_search'
     get 'lookup', to: 'courses#lookup'
     get 'unarchive', to: 'courses#unarchive'
     get 'sort', to: 'courses#sort'
   end
  end
  resources :analytics
  resources :licensed_analytics
    
  get 'media/:id/:ds', :to => 'file#show', :constraints => { :ds => /[^\/]+/ }, :as => 'file'  
  get 'courses/:id/:quarter/:year/:course', :to => 'courses#show', constraints: CourseConstraint.new, :as => :course_report
  get 'media/:id/:end_date/:file_name', :to => 'media#view', constraints: MediaConstraint.new, :as => 'video_view'
  get 'audios/:id/:end_date/:file_name', :to => 'audios#view', constraints: MediaConstraint.new, :as => 'audio_view'

  get '/auth/shibboleth', as: :shibboleth
  get '/auth/developer', to: 'users/sessions#developer', as: :developer
  match '/auth/shibboleth/callback' => 'users/sessions#shibboleth', as: :callback, via: [:get, :post]
  get '/users/sign_in', :to => 'users/sessions#new', :as => :new_user_session
  get '/users/sign_out', :to => 'users/sessions#destroy', :as => :destroy_user_session

  # Log out
  get 'logout', :to => 'welcome#logout', as: :logout

  match '*a', :to => 'errors#routing', via: [:get]
end

app/models/course.rb
#
# @author Vivian <tchu@ucsd.edu>
#
class Course < ActiveRecord::Base
  has_many :reports, dependent: :delete_all
  has_many :media, through: :reports
  has_many :audioreports, dependent: :delete_all
  has_many :audios, through: :audioreports

  validates :quarter, presence: true
  validates :year, presence: true, length: { maximum: 4 },
                   format: { with: /\A\d{4}\z/, message: 'must be in number format' }
  validates :course, presence: true
  validates :instructor, presence: true

  ##
  # Enables copying
  #
  amoeba do
    enable
    clone [:media]
    clone [:reports]
    clone [:audios]
    clone [:audioreports]
  end
end

app/controllers/courses_controller.rb
#
# @author Vivian <tchu@ucsd.edu>
#
class CoursesController < ApplicationController
  include Dmr::ControllerHelper
  include Dmr::CourseControllerHelper
  before_action :authorize_student, only: [:show] if Rails.configuration.shibboleth
  before_action :authorize, only: [:index, :create, :edit, :update, :new, :destroy,
                                   :search, :archive, :archive_search, :unarchive]

  before_action :set_course, only: [:show, :edit, :update, :destroy, :clone_course, :send_email]
  before_action :set_sorted_media, only: [:show, :edit, :send_email, :update]
  before_action :set_current, only: [:show, :edit, :update, :clone_course, :send_email]

  ##
  # Handles GET index request to display last 10 Courses from the database
  # GET /courses/index
  #
  # @return [String] the resulting webpage of the last 10 Course objects
  #
  def index
    @courses = Course.order('created_at DESC').limit(10)
  end

  ##
  # Handles GET show request to display the details of a single Course object
  # GET /courses/1
  #
  # @return [String] the resulting webpage of a single object
  #
  def show
    render layout: false
  end

  ##
  # Handles GET new request to a new Course object
  # GET /courses/new
  #
  # @return [String] for creating a new Course
  #
  def new
    @course = Course.new
  end

  ##
  # Handles POST create a Course object
  # POST /courses
  #
  # @note if successful
  # @return [String] - redirect to the resulting webpage of all Course objects
  # @note if failure
  # @return [String] the new Course form
  #
  def create
    @course = Course.new(course_params)

    if @course.save
      session[:current_course] = @course.id.to_s
      redirect_to edit_course_path(@course), notice: 'Course was successfully created.'
    else
      render :new
    end
  end

  ##
  # Handles GET edit a Course object
  # GET /courses/1/edit
  #
  # @return [String] the resulting webpage with the Course object
  #
  def edit
    @is_archive = params[:isArchive]
  end

  ##
  # Handles PUT update a Course object
  # PATCH/PUT /courses/1
  #
  # @note if successful
  # @return [String] - redirect to the resulting webpage
  # @note if failure
  # @return [String] the edit Course form
  #
  def update
    remove_media_from_course(params[:media_ids], @course, params[:type]) if removing_item?
    change_media_order(params[:media_ids], @course, params[:commit], params[:type])
    if @course.update_attributes(course_params)
      send_email
    else
      render :edit
    end
  end

  ##
  # Handles GET delete a Course object
  # DELETE /courses/1
  #
  # @return [String] - redirect to the Object index page
  #
  def destroy
    @course.destroy
    redirect_to courses_path, notice: 'Course was successfully destroyed.'
  end

  ##
  # Handles GET search for Course object
  #
  def search
    return unless params[:search] && params[:search].present?
    @courses = course_search(params[:search]).order(:course)
    create_search_session(@courses)
  end

  ##
  # Clone a Course Reserve List object
  # /courses/clone_course?id=1
  #
  # @return [String] - redirect to the Course edit page
  #
  def clone_course
    new_course = @course.amoeba_dup
    return unless new_course.save!
    redirect_to edit_course_path(new_course), notice: 'Course was successfully cloned.'
  end

  ##
  # Archive Courses
  # /courses/archive
  #
  # @return [String] - redirect to the Courses index page
  #
  def archive
    if deleting_archive?
      delete_archive(params[:course_ids])
      redirect_to courses_path, notice: 'Courses were successfully destroyed.'
    elsif un_archive?
      unarchive_courses?(params[:course_ids])
      redirect_to courses_path, notice: 'Courses were successfully unarchived.'
    elsif archive_courses?(params[:course_ids])
      redirect_to courses_path, notice: 'Courses were successfully archived.'
    else
      redirect_to courses_path, alert: 'Courses were failed to archive.'
    end
  end

  ##
  # UnArchive Courses
  # /courses/unarchive
  #
  # @return [String] - redirect to the Courses index page
  #
  def unarchive
    if unarchive_courses?(params[:course_ids])
      redirect_to courses_path, notice: 'Courses were successfully unarchived.'
    else
      redirect_to courses_path, alert: 'Courses were failed to unarchive.'
    end
  end

  ##
  # Search for Courses to archive
  # /courses/archive_search
  #
  #
  def archive_search
    redirect_to welcome_index_path if params[:commit] == 'Cancel'
    @courses = archive_full_search(params).order(:course)
  end

  ##
  # Search Courses page
  # /courses/lookup
  #
  #
  def lookup; end

  ##
  # Handles POST a set of media ids to be added to the current Course object
  # POST /courses/add_to_course
  #
  # @return [String] - redirect to the Course edit page if successful
  #
  def add_to_course
    if deleting_media?
      remove_items
    elsif !session[:current_course].nil?
      add_media_to_course(params[:media_ids], session[:current_course], params[:type])
      message = 'Video was successfully added to Course.'
      message = 'Audio was successfully added to Course.' if params[:type]
      redirect_to edit_course_path(@course), notice: message
    else
      redirect_to courses_path, alert: 'No current Course is set.  Set the Course first.'
    end
  end

  ##
  # Handles GET send a confirmation email about the Course
  # GET /courses/send_mail
  #
  def send_email
    if send_list?
      CourseMailer.course_email(current_user, @course, @sorted_media, @sorted_audio).deliver_now
      redirect_to edit_course_path(@course), notice: 'The confirmation email has been sent.'
    else
      redirect_to edit_course_path(@course), notice: 'Course successfully updated.'
    end
  end

  ##
  # Handles GET sort the course list
  # GET /courses/sort
  #
  def sort
    course = Course.find(params[:course_id])
    sorting(course, params[:type], params[:column]) if course
    redirect_to edit_course_path(course), notice: 'Course List was successfully updated.'
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_course
    @course = Course.find(params[:id])
  end

  # Use callbacks to share common setup or constraints between actions.
  def set_sorted_media
    @sorted_audio = get_sorted_audio(@course)
    @sorted_media = get_sorted_media(@course)
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def course_params
    params.require(:course).permit(:quarter, :year, :course, :instructor, :end_date, media_ids: [])
  end

  def removing_item?
    params[:commit] == 'Remove Item(s)'
  end

  def send_list?
    params[:commit] == 'Send List'
  end

  def deleting_media?
    params[:commit] == 'Delete Selected Records'
  end

  def deleting_archive?
    params[:commit] == 'Delete'
  end

  def un_archive?
    params[:commit] == 'UnArchive'
  end

  def create_search_session(courses)
    @course_search_count = courses.count
    session[:search] = params[:search]
    session[:search_option] = params[:search_option] if params[:search_option]
  end

  def remove_items
    delete_media(params[:media_ids], params[:type])
    path = params[:type] ? audios_path : media_path
    redirect_to path, notice: 'Selected Records were successfully deleted.'
  end

  def set_current
    session[:current_course] = params[:id]
  end
end

app/helpers/courses_helper.rb
#
# @author Vivian <tchu@ucsd.edu>
#
module CoursesHelper
  ##
  # Builds friendly URL
  #
  # @param course [Course] the file name
  #
  # @return [String] url
  ##
  def course_report_path(course)
    "#{course.quarter}/#{course.year}/#{course.course.parameterize('_')}"
  end

  def video_view_path(media)
    view_url(media)
  end

  def audio_view_path(audio)
    view_url(audio)
  end

  def view_url(obj)
    "#{obj.end_date}/#{obj.file_name}"
  end
end

app/views/courses/_archive_search_result.html.erb
<div class="ribbon">
  <a href="#">Archive</a>
</div>
<%#= bootstrap_form_for :course, url: archive_courses_path do |f| %>
<%= form_tag archive_courses_path, method: "GET" do %> 
  <div class="container">
    <div class="row">
      <% if obj && obj[0] && !obj[0].course.include?('ARCHIVE')%>
        <%= submit_tag "Archive", name: 'commit', class: "btn btn-primary", data: { confirm: 'Are you sure you want to archive these courses? This operation cannot be undone.' }%>      
      <% else %>
        <%= submit_tag "Delete", name: 'commit', class: "btn btn-primary", data: { confirm: 'Are you sure you want to delete these courses? This operation cannot be undone.' }%>      
        <%= submit_tag "UnArchive", name: 'commit', class: "btn btn-primary", data: { confirm: 'Are you sure you want to unarchive these courses? This operation cannot be undone.' }%>
      <% end %>
      <br/><br/>
      <div class="panel panel-default">
        <table class="table table-striped table-hover table-bordered">
          <thead>
            <tr>
              <th class="col-xs-1" scope="col"><%= label_tag 'check_all', 'check_all', class: "hide-label"%><%= check_box_tag 'check_all_courses',false%></th>
              <th class="col-xs-4" scope="col">Course</th>
              <th class="col-xs-2" scope="col">Quarter</th>
              <th class="col-xs-2" scope="col">Year</th>
              <th class="col-xs-1" scope="col">Instructor</th>
            </tr>
          </thead>
          <tbody>
            <% obj.each do |c| %>
              <tr>
                <td><%= check_box_tag 'course_ids[]', c.id%></td>                  
                <td><%= link_to "#{c.course}", edit_course_path(c.id, :isArchive => "true"), 'data-no-turbolink' => true%></td>
                <td><%= c.quarter %></td>
                <td><%= c.year %></td>
                <td><%= c.instructor %></td>
              </tr>
            <% end %>
          <tbody>
        </table>
      </div>
    </div>
  </div>
<% end %>

app/views/courses/_audio_playlist.html.erb
<div id="tdr_content_content" style="width:70%;max-width:70%;">
  <h1 class="hide-label">Audio</h1>
<!--JWPlayer player config. and script-->	     
<div id="player">Loading the player...</div>

<% if @course.audioreports and @course.audioreports.size > 0 %> 
  <script type="text/javascript">
    let newWidth = 1;
    let parent = document.getElementById('player').parentElement;  
    jwplayer("player").setup({
      playlist: [{
      <% @sorted_audio.each do |m| %>
        <%
          if m
            #secure_token = grab_secure_token_url(m.file_name, Rails.configuration.secure_token_audio_baseurl)
            #audio_base_url = "#{Rails.configuration.secure_token_audio_baseurl}#{m.file_name}"
            wowzaURL = "#{Rails.configuration.wowza_audio_baseurl}#{m.file_name}"
          end
        %>
        <% if wowzaURL %>
          <% 
            thumbnailURL = "#{Rails.configuration.audio_file_path}#{m.file_name.gsub('.mp3','.jpg')}"
            if !url_exist?(thumbnailURL)
              thumbnailURL = "https://library.ucsd.edu/dmrthumbs/audio_icon.png"              
            end          
          %>
          sources: [
	        {file: "https://<%=wowzaURL%>/playlist.m3u8"}
	      ],
	      <!--title of media file-->
	      title: "<%= m.track %>",
	      
          <!--Brief media description text area-->
	      description: "Album: <%= m.album %> <br/>Year: <%= m.year %>",
	  	  
	      <!--add image: to display thumbnail-->
	      image: "<%= thumbnailURL%>"
	  
          },{
        <% end %>
      <% end %>
	
      }],
      visualplaylist:false,
      width: 300 ,
      height: 40,
      skin: 'vapor',
      rtmp: {bufferlength: 3},
    });
    jwplayer().on('ready', function() {
      resize();
      window.onresize = function() {
        resize();
      };
      var myVideos = jwplayer().getPlaylist();
      for (var i = 0; i < myVideos.length; i++) {
        document.getElementById('listbar').innerHTML += '<div style="margin:10px 0 0 0;" class=listbar_item id=video'+ i +' onClick="javascript:playThis('+i+')"><a href="javascript:playThis('+i+')"><img style="float: left; height: 50px; width: 50px; margin-right: 10px; margin-left:10px;" src="' + myVideos[i].image + '"></a><b>' + myVideos[i].title + '</b><br>' + myVideos[i].description + '</div><div class="jwplaylistdivider"></div>';
    }});
    jwplayer().on('play', function(){updateActiveDiv(jwplayer().getPlaylistItem().index);});
    function playThis(index) {
      jwplayer().playlistItem(index);
      updateActiveDiv(index);   
    }
    
    function updateActiveDiv(index) {
      var activeDiv = document.getElementsByClassName("active");
      if (activeDiv[0] != null) {
         activeDiv[0].className = "listbar_item";
      }
      var div = document.getElementById( 'video'+index );
      div.className += " active";    
    }
    
    function resize() {
      let currentWidth = parent.offsetWidth;
      jwplayer().resize(currentWidth * newWidth, 40);
    }    	
  </script>
<% end %>
  <div id="listbar" style="height:300px;width:100%;overflow-y: scroll; align:center;"></div>
  </div>
</div>

app/views/courses/_audio_view.html.erb
<% if @course.audioreports and @course.audioreports.size > 0 %>
  <% counter = 0 %>
  <table class="table table-striped table-hover table-bordered">
    <thead>
      <tr>
        <th class="col-xs-1" scope="col"><%= label_tag 'check_all', 'check_all', class: "hide-label"%><%= check_box_tag 'check_all',false%></th>
        <th class="col-xs-1" scope="col">No</th>
        <th class="col-xs-3" scope="col">Track<%=link_to (image_tag "sorting_icon.png",  alt: '', class: 'sorting'), sort_courses_path(course_id: @course, type: 'audio', column: 'track'), 'data-no-turbolink' => true  %></th>
        <th class="col-xs-2" scope="col">Album<%=link_to (image_tag "sorting_icon.png",  alt: '', class: 'sorting'), sort_courses_path(course_id: @course, type: 'audio', column: 'album'), 'data-no-turbolink' => true  %></th>
        <th class="col-xs-2" scope="col">Call Number<%=link_to (image_tag "sorting_icon.png",  alt: '', class: 'sorting'), sort_courses_path(course_id: @course, type: 'audio', column: 'call_number'), 'data-no-turbolink' => true  %></th>
        <th class="col-xs-1" scope="col">Year<%=link_to (image_tag "sorting_icon.png",  alt: '', class: 'sorting'), sort_courses_path(course_id: @course, type: 'audio', column: 'year'), 'data-no-turbolink' => true  %></th>
        <th class="col-xs-1" scope="col">File Name<%=link_to (image_tag "sorting_icon.png",  alt: '', class: 'sorting'), sort_courses_path(course_id: @course, type: 'audio', column: 'file_name'), 'data-no-turbolink' => true  %></th>
      </tr>
    </thead>
    <tbody>	
      <% sorted_audio.each do |m| %>
        <% counter += 1 %> 
        <tr>
          <td><fieldset><legend class="hide-label">Type</legend><%= label_tag "media_ids_#{m.id}", 'media_ids[]', class: "hide-label"%><%= check_box_tag 'media_ids[]', m.id, false, id: "media_ids_#{m.id}"%></fieldset></td>
          <td><%= counter %></td>          
          <td><%= m.track %></td>
          <td><%= m.album %></td>        
          <td><%= m.call_number %></td>
          <td><%= m.year %></td>
          <td><%= m.file_name %></td>
        </tr>
      <% end %>  
    <tbody>
  </table>    
  <div class="center-block">
    <%= hidden_field_tag 'type', 'audio' %>
    <%= f.submit "Remove Item(s)", class: "btn btn-primary"%>
    <%= f.submit "Move Up One", class: "btn btn-primary"%>
    <%= f.submit "Move Down One", class: "btn btn-primary"%>
  </div>  
<% end %>  	    

app/views/courses/_form.html.erb
<div class="required">
  <%= f.text_field :course, label: "Course"%>
</div>
<div class="required">
  <%#= f.text_field :quarter, label: "Quarter"%>
  <%= f.select :quarter, [["Fall", "Fall"],["Winter", "Winter"],["Spring", "Spring"],["Summer", "Summer"]], { label: "Quarter" }, { class: "selectpicker"} %>
</div>
<div class="required">
  <%= f.text_field :year, label: "Year"%>
</div>
<div class="required">
  <%= f.text_field :instructor, label: "Instructor"%>
</div>
<div class="form-group">
  <% e_date = @course.end_date ? @course.end_date : ""%>
  <label class="control-label" for="course_end_date">End Date</label>
  <input type="text" name="course[end_date]" id="course_end_date" value="<%= e_date%>" size="20" placeholder="YYYY-MM-DD" class="enddatepicker form-control" data-date-format="yyyy-mm-dd"/>
</div>

app/views/courses/_media_view.html.erb
<% if @course.reports and @course.reports.size > 0 %>
  <% counter = 0 %>
  <table class="table table-striped table-hover table-bordered">
    <thead>
      <tr>
        <th class="col-xs-1" scope="col"><%= label_tag 'check_all', 'check_all', class: "hide-label"%><%= check_box_tag 'check_all',false%></th>
        <th class="col-xs-1" scope="col">No</th>
        <th class="col-xs-3" scope="col">Title<%=link_to (image_tag "sorting_icon.png", alt: '', class: 'sorting'), sort_courses_path(course_id: @course, type: 'video', column: 'title'), 'data-no-turbolink' => true  %></th>
        <th class="col-xs-2" scope="col">Director<%=link_to (image_tag "sorting_icon.png",  alt: '', class: 'sorting'), sort_courses_path(course_id: @course, type: 'video', column: 'director'), 'data-no-turbolink' => true  %></th>
        <th class="col-xs-2" scope="col">Call Number<%=link_to (image_tag "sorting_icon.png",  alt: '', class: 'sorting'), sort_courses_path(course_id: @course, type: 'video', column: 'call_number'), 'data-no-turbolink' => true  %></th>
        <th class="col-xs-1" scope="col">Year<%=link_to (image_tag "sorting_icon.png",  alt: '', class: 'sorting'), sort_courses_path(course_id: @course, type: 'video', column: 'year'), 'data-no-turbolink' => true  %></th>
        <th class="col-xs-1" scope="col">File Name<%=link_to (image_tag "sorting_icon.png",  alt: '', class: 'sorting'), sort_courses_path(course_id: @course, type: 'video', column: 'file_name'), 'data-no-turbolink' => true  %></th>
      </tr>
    </thead>
    <tbody>		    
      <% sorted_media.each do |m| %>
        <% counter += 1 %> 
        <tr>
          <td><fieldset><legend class="hide-label">Type</legend><%= label_tag "media_ids_#{m.id}", 'media_ids[]', class: "hide-label"%><%= check_box_tag 'media_ids[]', m.id, false, id: "media_ids_#{m.id}"%></fieldset></td>
          <td><%= counter %></td>          
          <td><%= m.title %></td>
          <td><%= m.director %></td>
          <td><%= m.call_number %></td>
          <td><%= m.year %></td>
          <td><%= m.file_name %></td>
        </tr>
      <% end %>  
    <tbody>
  </table>    
  <div class="center-block">
    <%= f.submit "Remove Item(s)", class: "btn btn-primary"%>
    <%= f.submit "Move Up One", class: "btn btn-primary"%>
    <%= f.submit "Move Down One", class: "btn btn-primary"%>
  </div>  
<% end %>  	    

app/views/courses/_search_result.html.erb
<%= form_tag archive_courses_path, method: "GET" do %> 
  <div class="container">
    <div class="row">
      <% if obj && obj[0] && !obj[0].course.include?('ARCHIVE')%>
        <%= submit_tag "Archive", name: 'commit', class: "btn btn-primary", data: { confirm: 'Are you sure you want to archive these courses? This operation cannot be undone.' }%>      
      <% else %>
        <%= submit_tag "Delete", name: 'commit', class: "btn btn-primary", data: { confirm: 'Are you sure you want to delete these courses? This operation cannot be undone.' }%>      
      <% end %>
      <br/><br/>
      <div class="panel panel-default">
        <table class="table table-striped table-hover table-bordered">
          <thead>
            <tr>
              <th class="col-xs-1" scope="col"><%= label_tag 'check_all', 'check_all', class: "hide-label"%><%= check_box_tag 'check_all_courses',false%></th>
              <th class="col-xs-4" scope="col">Course</th>
              <th class="col-xs-2" scope="col">Quarter</th>
              <th class="col-xs-2" scope="col">Year</th>
              <th class="col-xs-1" scope="col">Instructor</th>
              <th class="col-xs-1" scope="col" style="min-width:100px;">End Date</th>
            </tr>
          </thead>
          <tbody>
            <% obj.each do |c| %>
              <tr>
                <td><%= check_box_tag 'course_ids[]', c.id%></td>                  
                <td><%= link_to "#{c.course}", edit_course_path(c.id), 'data-no-turbolink' => true%></td>
                <td><%= c.quarter %></td>
                <td><%= c.year %></td>
                <td><%= c.instructor %></td>
                <td><%= c.end_date %></td>
              </tr>
            <% end %>
          <tbody>
        </table>
      </div>
    </div>
  </div>
<% end %>

app/views/courses/archive_search.html.erb
<div class="ribbon">
  <a href="#">Archive</a>
</div>
<% if @courses && @courses.count > 0%>
  <div class="text-center">
    Displaying <b><%= @courses.count %></b> results<br/>
  </div>       
  <%= render :partial => 'archive_search_result' , :locals => {:obj => @courses}%> 
<% elsif @courses && @courses.count == 0%>
  <div class="text-center">There were no results for the search: "<%= params[:search]%>"</div>
<% end %>

app/views/courses/edit.html.erb
<% if @is_archive %>
<div class="ribbon">
  <a href="#">Archive</a>
</div>
<% end %>
<div class="container">
  <div class="row">
    <div class="col-sm-10">
	  <h3>Course Reserve List</h3>
      <%= render :partial => 'shared/error_messages' , :locals => {:obj => @course}%>
      <p class="required">* Required field </p>

      <%= bootstrap_form_for @course, :required=>true do |f| %>
        <%= hidden_field_tag 'form_action' %>
	    <%= render :partial => 'form' , :locals => {:f => f}%>
	    <div class="center-block">
	      <%= f.submit "Save", class: "btn btn-primary"%>
	      <%= link_to "Delete", @course, method: :delete, data: { confirm: 'Are you sure?' }, class: "btn btn-primary"%>
	      <%= link_to "Clone", clone_course_courses_path(:id => "#{@course.id}"), class: "btn btn-primary", 'data-no-turbolink' => true %>
	      <%= link_to "View", course_report_path(@course), class: "btn btn-primary" , 'data-no-turbolink' => true, :onclick=>"window.open(this.href,'video_player', 'height=700, width=1000');return false;" %>
	      <%= f.submit "Send List", class: "btn btn-primary"%>
	      <%= link_to "Archive", archive_courses_path(:course_ids => ["#{@course.id}"]), class: "btn btn-primary" if !@course.course.include?('ARCHIVE')%>	      
	      <%= link_to "UnArchive", unarchive_courses_path(:course_ids => ["#{@course.id}"]), class: "btn btn-primary" if @course.course.include?('ARCHIVE')%>	
	    </div>	    
	    <%= render :partial => 'media_view' , :locals => {:f => f, :sorted_media => @sorted_media}%>
	    <%= render :partial => 'audio_view' , :locals => {:f => f, :sorted_audio => @sorted_audio}%>
	  <%end%>
    </div>
  </div>
</div>

app/views/courses/index.html.erb
<div class="text-center"><h3>Listing Courses</h3></div>
<div class="container">
  <div class="row">
    <div class="panel panel-default">
		<table class="table table-striped table-hover">
		  <thead>
		    <tr>
		      <th scope="col">Course</th>    
		      <th scope="col">Quarter</th>
		      <th scope="col">Year</th>
		      <th scope="col">Instructor</th>
		      <th scope="col">End Date</th>
		    </tr>
		  </thead>
		
		  <tbody>
		    <% @courses.each do |course| %>
		      <tr>
		        <td><%= link_to "#{course.course}", edit_course_path(course.id), 'data-no-turbolink' => true%></td>      
		        <td><%= course.quarter %></td>
		        <td><%= course.year %></td>
		        <td><%= course.instructor %></td>
		        <td><%= course.end_date %></td>
		      </tr>
		    <% end %>
		  </tbody>
		</table>
    </div>
  </div>
</div>

app/views/courses/lookup.html.erb
<div class="ribbon">
  <a href="#">Archive</a>
</div>

<div class="container">
  <div class="row">
    <div class="col-sm-10">
	  <h3>Search Courses</h3>
      <%= form_tag archive_search_courses_path, method: "GET" do %> 
         <div class="form-group">
           <label class="control-label" for="course_q">Course</label>
           <%= text_field_tag :course_q, params[:course_q], class: "form-control"%>
         </div>       
         <div class="form-group">
           <label class="control-label" for="year_q">Year</label>
           <%= text_field_tag :year_q, params[:year_query], class: "form-control"%>
         </div>
         <div class="form-group">
           <label class="control-label" for="instructor_q">Instructor</label>
           <%= text_field_tag :instructor_q, params[:instructor_query], class: "form-control"%>
         </div>
         <div class="center-block">                 
           <%= submit_tag "Search", name: 'commit', class: "btn btn-primary" %>
           <%= submit_tag "Cancel", name: 'commit', class: "btn btn-primary" %>
         </div>
       <% end %>

    </div>
  </div>
</div>